Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml	(revision 4592)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml	(revision 4694)
@@ -2,5 +2,5 @@
   <Table Name="" Member="Resources">
     <Type Name="Resource" InheritanceCode="Resource" IsInheritanceDefault="true">
-      <Column Name="ResourceID" AutoSync="Never" Type="System.Guid" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
+      <Column Name="ResourceID" AutoSync="OnInsert" Type="System.Guid" IsPrimaryKey="true" CanBeNull="false" />
       <Column Name="Name" Type="System.String" CanBeNull="false" />
       <Column Name="Description" Type="System.String" CanBeNull="true" />
@@ -10,8 +10,8 @@
       <Type Name="Client" InheritanceCode="Client">
         <Column Name="ProcessorType" Type="System.String" CanBeNull="true" />
-        <Column Name="NumberOfProcessors" Type="System.Int32" DbType="int" CanBeNull="true" />
-        <Column Name="NumberOfThreads" Type="System.Int32" CanBeNull="true" />
-        <Column Name="IPAdresse" Type="System.String" CanBeNull="true" />
-        <Column Name="MemorySize" Type="System.Int32" CanBeNull="true" />
+        <Column Name="NumberOfProcessors" Type="System.String" CanBeNull="true" />
+        <Column Name="NumberOfThreads" Type="System.String" CanBeNull="true" />
+        <Column Name="IPAdress" Type="System.String" CanBeNull="true" />
+        <Column Name="MemorySize" Type="System.String" CanBeNull="true" />
         <Column Name="OperatingSystem" Type="System.String" CanBeNull="true" />
       </Type>
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml.layout
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml.layout	(revision 4592)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml.layout	(revision 4694)
@@ -15,5 +15,5 @@
       </nestedChildShapes>
     </classShape>
-    <inheritanceConnector edgePoints="[(2.86155808614238 : 2.67484781901042); (2.86155808614238 : 3.5); (1.75 : 3.5); (1.75 : 3.875)]" fixedFrom="NotFixed" fixedTo="NotFixed" TargetRelationshipDomainClassId="7a7fe09e-e9ef-4b01-9ff3-bde95e827b62">
+    <inheritanceConnector edgePoints="[(3.125 : 2.67484781901042); (3.125 : 3.5); (1.75 : 3.5); (1.75 : 3.875)]" fixedFrom="NotFixed" fixedTo="NotFixed" TargetRelationshipDomainClassId="7a7fe09e-e9ef-4b01-9ff3-bde95e827b62">
       <nodes>
         <classShapeMoniker Id="ea129a98-d63f-4c3a-a3e8-dff64ad53c30" />
@@ -27,5 +27,5 @@
       </nestedChildShapes>
     </classShape>
-    <inheritanceConnector edgePoints="[(3.14639176514791 : 2.67484781901042); (3.14639176514791 : 3.5); (4.625 : 3.5); (4.625 : 3.875)]" fixedFrom="NotFixed" fixedTo="NotFixed" TargetRelationshipDomainClassId="7a7fe09e-e9ef-4b01-9ff3-bde95e827b62">
+    <inheritanceConnector edgePoints="[(3.125 : 2.67484781901042); (3.125 : 3.5); (4.625 : 3.5); (4.625 : 3.875)]" fixedFrom="NotFixed" fixedTo="NotFixed" TargetRelationshipDomainClassId="7a7fe09e-e9ef-4b01-9ff3-bde95e827b62">
       <nodes>
         <classShapeMoniker Id="ea129a98-d63f-4c3a-a3e8-dff64ad53c30" />
@@ -39,5 +39,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(4.125 : 1.84699625651042); (5.125 : 1.84699625651042)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(4.125 : 2.01147048950195); (5.125 : 2.01147048950195)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/ClientManagmentDataContext/Resource/Resource_ResourceResourceGroup" />
       <nodes>
@@ -46,5 +46,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(4.125 : 1.48599812825521); (5.125 : 1.48599812825521)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(4.125 : 1.56823524475098); (5.125 : 1.56823524475098)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/ClientManagmentDataContext/Resource/Resource_ResourceResourceGroup1" />
       <nodes>
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.designer.cs
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.designer.cs	(revision 4592)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.designer.cs	(revision 4694)
@@ -39,9 +39,8 @@
 
 
-    public ClientManagmentDataContext()	:
-				base(@"Data Source=nb-1\sqlexpress;Initial Catalog=HeuristicLab.ClientManagment;Integrated Security=SSPI;", mappingSource)
-		{
-			OnCreated();
-		}
+    public ClientManagmentDataContext() :
+      base(global::HeuristicLab.Services.Authentication.DataAccess.Properties.Settings.Default.ClientManagementConnectionString, mappingSource) {
+      OnCreated();
+    }
 
 		public ClientManagmentDataContext(string connection) : 
@@ -128,5 +127,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ResourceID", IsPrimaryKey=true, IsDbGenerated=true)]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ResourceID", AutoSync=AutoSync.OnInsert, IsPrimaryKey=true)]
 		public System.Guid ResourceID
 		{
@@ -284,11 +283,11 @@
 		private string _ProcessorType;
 		
-		private System.Nullable<int> _NumberOfProcessors;
-		
-		private System.Nullable<int> _NumberOfThreads;
-		
-		private string _IPAdresse;
-		
-		private System.Nullable<int> _MemorySize;
+		private string _NumberOfProcessors;
+		
+		private string _NumberOfThreads;
+		
+		private string _IPAdress;
+		
+		private string _MemorySize;
 		
 		private string _OperatingSystem;
@@ -300,11 +299,11 @@
     partial void OnProcessorTypeChanging(string value);
     partial void OnProcessorTypeChanged();
-    partial void OnNumberOfProcessorsChanging(System.Nullable<int> value);
+    partial void OnNumberOfProcessorsChanging(string value);
     partial void OnNumberOfProcessorsChanged();
-    partial void OnNumberOfThreadsChanging(System.Nullable<int> value);
+    partial void OnNumberOfThreadsChanging(string value);
     partial void OnNumberOfThreadsChanged();
-    partial void OnIPAdresseChanging(string value);
-    partial void OnIPAdresseChanged();
-    partial void OnMemorySizeChanging(System.Nullable<int> value);
+    partial void OnIPAdressChanging(string value);
+    partial void OnIPAdressChanged();
+    partial void OnMemorySizeChanging(string value);
     partial void OnMemorySizeChanged();
     partial void OnOperatingSystemChanging(string value);
@@ -337,6 +336,6 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_NumberOfProcessors", DbType="int")]
-		public System.Nullable<int> NumberOfProcessors
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_NumberOfProcessors")]
+		public string NumberOfProcessors
 		{
 			get
@@ -358,5 +357,5 @@
 		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_NumberOfThreads")]
-		public System.Nullable<int> NumberOfThreads
+		public string NumberOfThreads
 		{
 			get
@@ -377,20 +376,20 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IPAdresse")]
-		public string IPAdresse
-		{
-			get
-			{
-				return this._IPAdresse;
-			}
-			set
-			{
-				if ((this._IPAdresse != value))
-				{
-					this.OnIPAdresseChanging(value);
-					this.SendPropertyChanging();
-					this._IPAdresse = value;
-					this.SendPropertyChanged("IPAdresse");
-					this.OnIPAdresseChanged();
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IPAdress")]
+		public string IPAdress
+		{
+			get
+			{
+				return this._IPAdress;
+			}
+			set
+			{
+				if ((this._IPAdress != value))
+				{
+					this.OnIPAdressChanging(value);
+					this.SendPropertyChanging();
+					this._IPAdress = value;
+					this.SendPropertyChanged("IPAdress");
+					this.OnIPAdressChanged();
 				}
 			}
@@ -398,5 +397,5 @@
 		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_MemorySize")]
-		public System.Nullable<int> MemorySize
+		public string MemorySize
 		{
 			get
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/HeuristicLab.Services.Authentication.DataAccess.csproj
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/HeuristicLab.Services.Authentication.DataAccess.csproj	(revision 4592)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/HeuristicLab.Services.Authentication.DataAccess.csproj	(revision 4694)
@@ -31,4 +31,10 @@
     <WarningLevel>4</WarningLevel>
   </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HLAuthenticationDataAccess.pfx</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
   <ItemGroup>
     <Reference Include="System" />
@@ -61,4 +67,5 @@
       <SubType>Designer</SubType>
     </None>
+    <None Include="HLAuthenticationDataAccess.pfx" />
     <None Include="Properties\Settings.settings">
       <Generator>SettingsSingleFileGenerator</Generator>